<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070628;17130200">
	<META NAME="CHANGED" CONTENT="20070710;12354500">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Build SLR(1) Parse
Table</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#definition"><U>Definition</U></A></P>
<P STYLE="margin-bottom: 0in"><A HREF="#How to Build SLR(1) Parse Table|outline">How
to Build SLR(1) Parse Table</A></P>
<UL>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#Building the DFA|outline">Building
	the DFA</A></P>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#Building the Parse Table|outline">Building
	the Parse Table</A></P>
</UL>
<P STYLE="margin-bottom: 0in"><A HREF="#SLR(1) Parsing|outline"><U>SLR(1)
Parsing</U></A></P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="definition"></A>
Definition</H2>
<P STYLE="margin-bottom: 0in">The type of LR parsing in JFLAP is
SLR(1) Parsing. 
</P>
<P><I>S</I> stands for simple LR.<BR>L means the input string is
processed from left to right, as in LL(1) parsing. <BR>R means the
derivation will be a rightmost derivation (the rightmost variable is
replaced at each step).<BR>1 means that one symbol in the input
string is used to help guide the parse.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="how to"></A><A NAME="How to Build SLR(1) Parse Table|outline"></A>
How to Build SLR(1) Parse Table</H2>
<P STYLE="margin-bottom: 0in"><A NAME="language1"></A>We will begin
by loading the same grammar that we used for building the LL(1) Parse
Table. You can enter that grammar or load the file, <A HREF="grammarToLL.jff">grammarToLL.jff</A>.
After loading the grammar, click on <B>Input </B>and then <B>Build
SLR(1) Parse Table</B>. A new rule is automatically added to the
grammar, “S'-&gt;S”, resulting in a new start variable, “S'”,
that does not appear in any right-hand sides. Your window should look
like this after entering the SLR(1) Parse mode. 
</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/slrparse.png" NAME="Graphic2" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Just like LL(1) Parse, we
have to enter the <B>FIRST</B> and <B>FOLLOW</B> sets. If you have
not already, read the tutorial on <B>FIRST </B>and <B>FOLLOW </B>sets
in the <B>Build LL(1) Parse Table </B>tutorial. After entering proper
<B>FIRST</B> and <B>FOLLOW</B> sets, click on <B>Next</B>. You should
get a message from JFLAP and your window should look like this : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>*NOTE </B>: You can click
the <B>Do Step</B> button twice, to make JFLAP automatically fill the
<B>FIRST</B> and <B>FOLLOW</B> sets.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_1.png" NAME="Graphic3" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Building the DFA|outline"></A>
<B>Building the DFA</B></H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">We now
build a DFA that models the SLR(1) process. Each state will have a
label with marked productions called items. The marker is shown as
“.”. Those symbols to the left of the marker in an item are
already on the parsing stack, and those symbols to the right of the
marker still need to be pushed on the parsing stack. All the items
for one state are called an item set.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">JFLAP
now asks you whether you want to define the initial set or not. If
you click “Yes”, JFLAP will pop up a small window where you can
define the initial set. If you click “No”, then JFLAP will
automatically create the initial set for you. Suppose you clicked
“Yes”, then you will see a window like this one :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_2.png" NAME="Graphic4" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">When
you click on a production, you will notice that all possible items
derivable from that production appear. Since nothing is added to the
stack yet, click on the production “S'-&gt; .S”. Since the marker
is in front of a variable, “S”, all of the S items with the “.”
as the leftmost symbol must be added to the item set. In our grammar,
only production “S-&gt;.aABb” fits the rule.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">*<B>NOTE </B>: You can click
on <B>Finish</B> to let JFLAP create the item set for this state.
When you are finished, your window should look like this : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_3.png" NAME="Graphic5" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">You now have your first
state “q0” created as shown in the following picture.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_3-1.png" NAME="Graphic5" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>*Note</B> : you can make
the panel with the state larger by clicking on and moving the
horizontal and vertical bars in the window. You may also want to
enlarge the window to full screen.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">We should add more states
and transitions to complete this diagram. First click on the “Goto
Set on Symbol” button on the diagram panel, it is the button next
to the “arrow” button. From our initial state q0, we know there
are only two transitions possible. One is with variable S and the
other one is with terminal “a”, since both of these symbols come
right after the marker in the item set.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">After clicking the “Goto
Set on Symbol” button, click on our initial state and drag the
mouse and release it at the spot you want to create a new state.
Next, JFLAP asks you to enter the symbol for the transition. Let's
put variable “S”. When you enter the variable S, you will see the
window “Goto on S”. Now click on the production “S'-&gt;S.”,
since we have moved from our initial state using input “S”,
variable “S” is no longer behind the marker. It is now on the
left side of the marker. Since there are no variables remaining on
the right side of the marker, there is no transition outgoing from
the new state. Our completed “Goto on S” should look like this :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_4.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=712 HEIGHT=574 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">We can add another
transition from q0 using the terminal “a”. Following the same
steps, we will end up with a “Goto on a” window. We add
production “S-&gt;a.ABb”, since we came to this new state using
terminal “a” (this models that “a” is pushed on the parsing
stack in the SLR(1) paring process). Now we have to examine the
variable “A”, since the marker is in front of it. We add the
productions from variable “A”, which start with the marker “.”.
There are two productions to add, production “A-&gt;.” and
“A-&gt;.aAc”. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">Now
after creating these two new states our diagram would look like this
: 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_5.png" NAME="Graphic7" ALIGN=MIDDLE WIDTH=712 HEIGHT=574 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">A state is a final state if
one of its items has the marker as the last symbol on the right-side
of the production. Since we now know that q1 is one of our final
states, we can click the attribute button (“arrow” button), then
right click on q1. We can select “final” to make the state q1
final. Try adding the remaining states and their item sets. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">After adding all the states
(or clicking on <B>Do Step</B>), your final diagram should look like
this :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_6.png" NAME="Graphic8" ALIGN=MIDDLE WIDTH=938 HEIGHT=703 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>*NOTE </B>: The grammar
window's sub-panels are resized to show the diagram.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>*NOTE </B>: You can click
on the states in the DFA and move them around for a nicer picture.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Building the Parse Table|outline"></A>
Building the Parse Table</H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">The DFA is used to build the
parse table. Each transition in the DFA results in either a shift
entry for a terminal or a goto entry for a variable. Each marked rule
with the marker at the right end (found in final states) results in
reduce rules. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, it's time to fill in
entries in the parse table. We can start filling in the parse table
from row 0, which corresponds to state q0. From state q0, there are
two transitions resulting in two operations. The transition on the
“S” relates to “go to” state 1 (q1) and the transition on the
“a” relates to “shift” terminal “a” and go to state 2
(q2). Therefore, in the parse table row 0, put s2 (“s” stands for
“shift”) in column “a” and put 1 (means just go to state q1)
in column S. Now we are done filling the parse table for state q0.
Next step is filling in the parse table for q1, which corresponds to
row 1. When we reach state q1, we are done parsing since start
variable “S” is popped off the stack. So, at state q1, we should
accept the string. We fill the entry by typing “acc”, which
stands for accepted in column “$”, which implies there are no
symbols left to process. After filling in the first two rows of the
SLR parse table, your window should look like : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_7.png" NAME="Graphic9" ALIGN=MIDDLE WIDTH=938 HEIGHT=703 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">There are two transitions
out of state q2. Let's fill in row 2. For transition “a”, we can
put “s4” in column “a” in row 2. For transition “A”, we
can put the number 3 in column “A” in row 2. Since q2 is a final
state, it has at least one reduce rule (a rule with the marker at the
right end of the right-side of the rule). The reduce rule is
“A-&gt;lambda”, shown in JFLAP as “A-&gt;.”, and numbered in
JFLAP as rule number 3. We can put this reduce rule “r3” in row 2
in columns for all symbols in the <B>FOLLOW</B>(A), which are “b”
and “c”. Now we are done with row 2. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>*NOTE</B> : There are 4
operations that we use to fill in the parse table : “s” (shift)
and “r” (reduce) followed by the destination row number, “acc”
for accept, and just a destination row number to indicate transition
using variable.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Try filling in the entries
for each remaining row. When finished the SLR parse table would look
like this : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_8.png" NAME="Graphic10" ALIGN=MIDDLE WIDTH=938 HEIGHT=703 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="SLR(1) Parsing|outline"></A>
SLR(1) Parsing</H2>
<P>We have finished the SLR (1) Parse table. Next, click on <B>Parse</B>
and in the SLR (1) Parsing window, input “aacbbcb” as the input
string. After clicking <B>Start</B>, press <B>Step</B>. Your window
should look like this now : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_9.png" NAME="Graphic11" ALIGN=MIDDLE WIDTH=734 HEIGHT=633 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Notice that we have a node
with terminal “a” in the tree panel. We achieved the first “a”,
so we would remove this “a” from the input remaining. The stack
is now filled with “2a0”, meaning that we have reached state 2
from state 0 using transition terminal “a”. You will also notice
that the operation that is applied to the input string is highlighted
in the parse table, “s2” in the “a” column. Whenever a
reduction is applied, both the entry in the parse table and the
production that actually performed the reduction will be highlighted.
Click <B>Step </B>several times, observing what happens until the
string is accepted. The final window should look like one of these : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_10.png" NAME="Graphic12" ALIGN=MIDDLE WIDTH=734 HEIGHT=633 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_11.png" NAME="Graphic13" ALIGN=MIDDLE WIDTH=734 HEIGHT=633 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_12.png" NAME="Graphic14" ALIGN=MIDDLE WIDTH=734 HEIGHT=633 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on Building SLR(1) Parse Table. Thanks for reading!</B></P>
</BODY>
</HTML>